/*
  COPYRIGHT NOTICE
  Copyright (c) 2012  Scott C. Neu and Arthur W. Toga

  This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package edu.ucla.loni.freesurfer.plugin;

import java.util.ListResourceBundle;

/**
 * List Resource Bundle that provides descriptions for Free Surfer "New" Curv
 * fields.
 *
 * @version 29 January 2009
 */
public class CurvFormatResources extends ListResourceBundle
{
    /** Constructs a Curv Format Resources. */
    public CurvFormatResources()
    {
    }

    /**
     * Gets the contents of the Resource Bundle.
     *
     * @return Object array of the contents, where each item of the array is a
     *         pair of Objects.  The first element of each pair is the key,
     *         which must be a String, and the second element is the value
     *         associated with that key.
     */
    public Object[][] getContents()
    {
	String rootName = CurvFormat.NATIVE_METADATA_FORMAT_NAME;

	Object[][] contents = {

	    // Node name + "/" + attribute name, followed by description
	    {rootName + "/" + CurvFormat.VERTEX_COUNT,
	     "Count of vertices (must match that of surface file to which " +
	     "this data is being associated.)"},
	    {rootName + "/" + CurvFormat.FACE_COUNT,
	     "Count of faces."},
	    {rootName + "/" + CurvFormat.VALS_PER_VERTEX,
	     "Number of values supplied per vertex (currently only 1 is " +
	     "supported)."}
	};

	return contents;
    }
}
